"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ScratchCard = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _RnScratchCard = require("./RnScratchCard");

var _ScratchGrid = require("./ScratchGrid");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ScratchCard = props => {
  const image = _reactNative.Image.resolveAssetSource(props.source);

  const [grid, setGrid] = (0, _react.useState)();
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    onLayout: event => {
      const {
        width,
        height
      } = event.nativeEvent.layout;

      if ((grid === null || grid === void 0 ? void 0 : grid.size) !== {
        width,
        height
      }) {
        const size = {
          width,
          height
        };
        setGrid(new _ScratchGrid.ScratchGrid(size, props.brushWidth));
      }
    }
  }, /*#__PURE__*/_react.default.createElement(_RnScratchCard.RnScratchCard, {
    image: image,
    brushWidth: props.brushWidth,
    onScratch: handleOnScratch,
    style: props.style
  }));

  function handleOnScratch(event) {
    if (props.onScratch && grid) {
      const {
        nativeEvent
      } = event;
      const x = Math.min(grid.size.width - 1, Math.max(0, nativeEvent.x));
      const y = Math.min(grid.size.height - 1, Math.max(0, nativeEvent.y));
      grid.update({
        x,
        y
      });
      props.onScratch(grid);
    }
  }
};

exports.ScratchCard = ScratchCard;
//# sourceMappingURL=index.js.map