import React, { useState } from 'react';
import { Image, View } from 'react-native';
import { RnScratchCard } from './RnScratchCard';
import { ScratchGrid } from './ScratchGrid';
export const ScratchCard = props => {
  const image = Image.resolveAssetSource(props.source);
  const [grid, setGrid] = useState();
  return /*#__PURE__*/React.createElement(View, {
    onLayout: event => {
      const {
        width,
        height
      } = event.nativeEvent.layout;

      if ((grid === null || grid === void 0 ? void 0 : grid.size) !== {
        width,
        height
      }) {
        const size = {
          width,
          height
        };
        setGrid(new ScratchGrid(size, props.brushWidth));
      }
    }
  }, /*#__PURE__*/React.createElement(RnScratchCard, {
    image: image,
    brushWidth: props.brushWidth,
    onScratch: handleOnScratch,
    style: props.style
  }));

  function handleOnScratch(event) {
    if (props.onScratch && grid) {
      const {
        nativeEvent
      } = event;
      const x = Math.min(grid.size.width - 1, Math.max(0, nativeEvent.x));
      const y = Math.min(grid.size.height - 1, Math.max(0, nativeEvent.y));
      grid.update({
        x,
        y
      });
      props.onScratch(grid);
    }
  }
};
//# sourceMappingURL=index.js.map